sfinae.h File Reference

Template meta-programming SFINAE helpers. More...

`#include <utl/core/impl.h>`
`#include <type_traits>`

Go to the source code of this file.

## Classes

struct | utl::meta::detail::when_< If >
struct | utl::meta::detail::when_< true >

## Namespaces

| utl
| STL's core language concepts.
| utl::meta
| utl::meta::detail

## Typedefs

template<bool If>
using | utl::meta::when = eval< detail::when_< If > >
| Well formed only if `If` is true. More...
template<bool If, typename _Tp = void>
using | utl::meta::enable_if = std::enable_if< If, _Tp >
| enable_if, imported from stl More...
template<bool If, typename _Tp = void>
using | utl::meta::enable_if_t = eval< enable_if< If, _Tp > >
| alias template for enable_if More...

## Detailed Description

Template meta-programming SFINAE helpers.

Copyright (C) 2018-2019 Christos Choutouridis

This program is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with this program. If not, see http://www.gnu.org/licenses/.

Definition in file sfinae.h.